/* mods by sgf@cfm.brown.edu 4/20/95
 *
 *  Note that these are really quick, stupid hacks, because the thing
 *  isn't worth spending any time on (SGI'll fix mediad/objsrvr someday)...
 *
 *  switched it around so it runs as daemon sleeping select on both a 
 *  timeout and input from a UNIX socket. A stupid client program writes
 *  eject or ignore commands to the socket. The ignore command is there
 *  for media and fs maintenance...
 *
 *	I didn't bother...
 *		syslogging - output goes to console.
 *		multiple devs - not a big deal, but don't need it...
 *		cleaning up much of anything - I gotta go do other stuff...
 *		(cleanup would include stuff like changing to mount(2) in 
 *		addition to degreasing the code...)
 *
 *	To make it work...
 *		cc -o automopper automopper.c -lds (-32 on IRIX 6)
 *		cc -o moctl moctl.c
 *		chmod 4711 moctl
 *		add an entry to fstab of the form
 *			/dev/dsk/dks0d3s7 /optical efs rw,nosuid 0 0
 *			(change the device to whatever...)
 *
 *	A matter of taste...
 *		If the thing's unable to mount a filesystem it auto-ejects
 *		the disk. This forces the fixer to 'moctl -i' to tell it
 *		to ignore the disk on next insertion for maintenance.
 *
 *	To do...
 *		Put it into a root-only mode where it goes into a media prep 
 *		loop of...
 *			- copy vh onto disk
 *			- mkfs 
 *			- mount
 *			- chmod 1777
 *			- umount
 *			- eject
 *			- repeat
 *		so the poor bozo just sits there like a Mac user swapping
 *		disks...
 *
 *              Maybe figure out if /dev/scsi/foo (dsp) can be used as
 *              a read or except descriptor in the select, so we don't
 *              have to wake up and poke it with sticks (TURs) every few secs.
 */


/*
From hewat@ill.fr  Mon Feb 15 23:47:22 1993
Date: Tue, 16 Feb 93 08:40:31 -0100
I have modified the routine "cdmount" by Kent Landfield to allow all users 
to mount magneto-optic drives.  The rountines are now called "mountmo"
(you can mount a read-only disk with "mountmo -r"),  and "umountmo", 
where the buffer is dumped to the disk before dismounting it. (It must still
be manually ejected.)

I hope SGI will eventually produce a daemon to mount such disks auto-
matically, as for cd's.

Alan Hewat, ILL Grenoble, FRANCE (hewat@ill.fr) Fax (France=33).76.48.39.06
*/

/*
* Further modified 9/93 by Dave Olson to support ejecting media
* on unmount on SGI systems (-e option on umount)
* Requires -lds when compiling.
* Note that the binary must be called mountmo, with a link to umountmo
* install it mod 4711, owned by root.  See the MNTPOINT define for
* the mountpoint that is used (must be in fstab).
*/

/*
**  Subsystem:   User Level mount for CD-ROM modified for magneto-optic
**  File Name:   mountmo.c
**                                                        
** This software is Copyright (c) 1991 by Kent Landfield.
** based on cdmount, modified by Alan Hewat for magneto-optic drives
**
** Permission is hereby granted to copy, distribute or otherwise 
** use any part of this package as long as you do not try to make 
** money from it or pretend that you wrote it.  This copyright 
** notice must be maintained in any copy made.
**
** Use of this software constitutes acceptance for use in an AS IS 
** condition. There are NO warranties with regard to this software.  
** In no event shall the author be liable for any damages whatsoever 
** arising out of or in connection with the use or performance of this 
** software.  Any use of this software is at the user's own risk.
**
**  If you make modifications to this software that you feel 
**  increases it usefulness for the rest of the community, please 
**  email the changes, enhancements, bug fixes as well as any and 
**  all ideas to me. This software is going to be maintained and 
**  enhanced as deemed necessary by the community.
**              
**              Kent Landfield
**              sparky!kent
**              kent@sterling.com
**
**              Alan Hewat
**              hewat@ill.fr
**
**		like they said...
**		Sam Fulcomer
**		sgf@cfm.brown.edu
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <mntent.h>
#include <string.h>
#include <malloc.h>
#include <dslib.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>


#define MNTPOINT "/optical"
#define SOCKETNAME "/tmp/.eyeear"
#define SLEEP_VAL 4		/* I don't really care... */
#ifndef NOFILE
#define NOFILE 20		/* gimme a break... */
#endif  /*NOFILE*/		/* gimme another ("ascii stupid question...")*/
#define MTAB 0
#define FSTAB 1
int debug;

char *finddev();
void prevent_removal();
void allow_removal();
char mcmd[] = "mount /optical";
char ucmd[] = "umount /optical";

int main(argc, argv)
int argc;
char **argv;
{
    char *cp, *ejectdev;
    char cmd[256], swab[256];
    int rc,  cnt, earhere, fromlen, domain, i, s;
    int readonly = 0;
    int doeject = 0;
    int ignore = 0;
    int mounted = 0;
    struct stat stb;
    extern char *optarg;
    extern int optind;
    extern int opterr;
    dsreq_t         *dsp;
    struct timeval sleepy_time;
    struct sockaddr_un earaddr, earwig;
    fd_set listenfds;

    sleepy_time.tv_sec = SLEEP_VAL;
    sleepy_time.tv_usec = 0;




    opterr = 0;

			/* ack, turn sorta into a daemon... */
    if (fork())
        exit(0);
    for (i = 0 ; i <= NOFILE ; (void) close(i++));
    /* this followin hack is one cause of the runaway inetd -sgf */
    (void) open("/", 0);
    (void) dup2(0, 1);
    i = open("/dev/tty", 2);
    if (i >= 0) {
        ioctl(i, TIOCNOTTY, (char *)0);
        (void) close(i);
    }
    i = open("/dev/console", 1);
    if (i < 0) {    /* ackkk!! */
        exit(5);
    }
    (void) dup2(i, 2);

    /*
    ** Setup IFS for system() protection...
    */
    if (putenv("IFS= \t\n") != 0) {
         (void) fprintf(stderr,"%s: IFS putenv failed...\n", cp);
         exit(1);
    }

    /*
    ** Setup PATH for execlp() protection...
    */
    if (putenv("PATH=/etc:/usr/etc:/bin:/usr/bin") != 0) {
         (void) fprintf(stderr,"%s: PATH putenv failed...\n", cp);
         exit(1);
    }

    /* check the mount point and be sure it's not a static link */
    if (lstat(MNTPOINT, &stb) != 0) {
        (void) fprintf(stderr, "%s: mount point missing\n", MNTPOINT);
        exit(1);
    }
    if ((stb.st_mode & S_IFMT) != S_IFDIR) {
        (void) fprintf(stderr, "%s: invalid mount point\n", MNTPOINT);
        exit(1);
    }

					/* might as well open only once... */
    if (!(ejectdev = finddev(MNTPOINT, FSTAB ))) {
	fprintf(stderr, "can't find device, check fstab\n");
	exit (2);
    } 
    dsp = dsopen(ejectdev, O_RDONLY);
    if (!dsp) {
    	fprintf(stderr, "can't open %s to eject media\n", ejectdev);
    	exit (2);
    }

    /***open UNIX socket to listen for eject and ignore requests...****/

    (void) unlink(SOCKETNAME);
    earhere = socket(AF_UNIX, SOCK_STREAM, 0);
    if (earhere < 0) {
    	fprintf(stderr, "can't open socket\n");
    	exit(1);
    }
    earaddr.sun_family = AF_UNIX;
    strcpy(earaddr.sun_path, SOCKETNAME);
    if (bind(earhere, &earaddr, strlen(earaddr.sun_path) + 2) < 0) {
        fprintf(stderr, "can't bind socket\n");
        exit(1);
    }
    chmod(SOCKETNAME, (mode_t) 00700);
    FD_ZERO(&listenfds);
    listen(earhere, 5);
    domain = AF_UNIX;
    fromlen = sizeof(earwig);




    for (;;) {
	if ( ignore ) {
    	    FD_SET(earhere, &listenfds);
	    if ( select(10,&listenfds,0,0,0) <= 0 ) {
		fprintf(stderr,"%s: unknown error in select\n", argv[0]);
	    } else {
				/* yeah, well... I _like_ goto... */
		goto earfull; 
	    }
	}
		
	mounted = (ejectdev = finddev(MNTPOINT, MTAB )) ? 1 : 0;
        FD_SET(earhere, &listenfds);
        if ( select(10,&listenfds,0,0,&sleepy_time) <= 0 ) {
			/*  assume timeout */
	    if ( ! mounted ) {
	        if ( ! testunitready00(dsp)) {
		    prevent_removal(dsp);
                    if (system(mcmd)) {
		        Eject(dsp);
		        fprintf(stderr,
			  "%s: mount failed; please check filesystem/format\n", 
					argv[0]);
	            } 
	        } 
    	    } 
        } else {		/* we have lift-off... */
earfull:
	    s = accept(earhere, &earwig, &fromlen);
	    if (s < 0) {
                if (errno != EINTR)
                  fprintf(stderr, "%s: accept croaked and no EINTR\n", argv[0]);
                continue;
            }
	    if ( (cnt = read(s, swab, 1)) != 1 ) {
		if (cnt <= 0) {
                    fprintf(stderr,"Lost connection\n");
                    exit(1);
		}
	    }
				/* _could_ add lots more stuff here like
				 * returning diagnostic to client, and
				 * correctly use mount(2) rather than system
				 * but I can't be bothered, since SGI'll get
				 * it's act together and inform mediad that
				 * other types exist...
				 */
	    switch (swab[0]) {
	    case 'E': 
		if (mounted) {
		    if ( ! system(ucmd) ) {
			mounted = 0;
			Eject(dsp);
		    }
		} else {
		    Eject(dsp);
		}
		break;
	    case 'I': 
		if (mounted) {
		    if ( ! system(ucmd) ) {
			mounted = 0;
			allow_removal(dsp);
		    }
		} else {
		    allow_removal(dsp);
		}
		ignore = 1;
		break;
	    case '&':
		if (mounted) {
                    if ( ! system(ucmd) ) {
                        mounted = 0;
                        Eject(dsp);
                    }
                } else {
                    Eject(dsp);
                }
		dsclose(dsp);
		fprintf(stderr, "%s: toast\n", argv[0]);
		exit(-1);
		break;
	    default:
		ignore = 0;
		break;
	    }
	}
    }
}

char *
finddev(char *mntpnt, int fstab)
{
        struct mntent *mnt;
        char *mntdev;
	FILE *mtab;

	/* want to know what it is before it's mounted... */
	if ( fstab ) {
            mtab = setmntent("/etc/fstab", "r");
	/* or perhaps guess that it is mounted... */
        } else {
	    mtab = setmntent("/etc/mtab", "r");
	}
        while((mnt=getmntent(mtab)) && strcmp(mnt->mnt_dir, mntpnt))
                ;
        if(!mnt) {
                endmntent(mtab);
                return NULL;    /* couldn't find mount point in mtab */
        }

        /* hack, hack.  Only deal with scsi disks; either via dks
         * or ds.  dks naming standard is:
                dks#d#xxxx
         * where first # is 1 or 2 digits for controller, and
         * second is 1 or 2 digits of target ID.  Rest is partition
         * identifier. */
        if(strncmp("/dev/scsi/", mnt->mnt_fsname, 10) == 0)
                mntdev = strdup(mnt->mnt_fsname);
        else if(strncmp("/dev/dsk/dks", mnt->mnt_fsname, 12) == 0 &&
                (mntdev = malloc(32))) {
                int ctlr, target;
                char *nxt;
                ctlr = strtoul(mnt->mnt_fsname+12, &nxt, 10);
                if(nxt)
                        target = strtoul(nxt+1, &nxt, 10);
                if(nxt)
                        sprintf(mntdev, "/dev/scsi/sc%dd%dl0", ctlr, target);
                else {
                        free(mntdev);
                        mntdev = NULL;
                }
        }
        else
                mntdev = NULL;

        endmntent(mtab);
        return mntdev;
}

void
ejectmedia( struct dsreq *dsp )
{
        fillg0cmd( dsp, CMDBUF( dsp ),  G0_LOAD, 1, 0, 0, 2, 0 );
        filldsreq( dsp, NULL, 0, DSRQ_READ|DSRQ_SENSE );
        doscsireq( getfd( dsp ), dsp );
}

/* prevent front-panel-eject while mounted */
void
prevent_removal( struct dsreq *dsp )
{
        fillg0cmd( dsp, CMDBUF( dsp ), G0_PREV, 0, 0, 0, 1, 0 );
        filldsreq( dsp, NULL, 0, DSRQ_READ|DSRQ_SENSE );
        doscsireq( getfd( dsp ), dsp );
}

/* allow front-panel-eject when not mounted - mostly useful for fs changes... */
void
allow_removal( struct dsreq *dsp )
{
        fillg0cmd( dsp, CMDBUF( dsp ), G0_PREV, 0, 0, 0, 0, 0 );
        filldsreq( dsp, NULL, 0, DSRQ_READ|DSRQ_SENSE );
        doscsireq( getfd( dsp ), dsp );
}


Eject(dsreq_t *dsp)
{
        int             ret, retries;

        dsdebug = debug;

        /* some drives don't allow software eject if prevent media removal
         * has been done, so be paranoid */
        allow_removal(dsp);

        ejectmedia( dsp );
        ret = (STATUS( dsp ) == STA_GOOD ? 0 : 3);
        if (ret != 0)
                fprintf( stderr, "Can't eject media from \n");
        else if(debug)
                fprintf( stderr, "ejected media from \n" );
        return (ret);
}


void
usage(char *progname)
{
    (void) fprintf(stderr, "\nusage: %s [ -dhve ]\
\n\noptions:\n\
      -d   show the mount command without executing it\n\
      -r   mount the media readonly (mount only)\n\
      -v   show the mount command and execute it\n\
      -e   eject the media after unmounting, if successful (unmount only)\n\
\n", progname);
}
